=== debian/changelog ===
xdp-tools (1.5.7-3) unstable; urgency=medium

  * Backport patch to fix flaky tests

 -- Luca Boccassi <bluca@debian.org>  Mon, 06 Oct 2025 16:17:27 +0100

xdp-tools (1.5.7-2) unstable; urgency=medium

  * autopkgtest: add dependencies for new tests

 -- Luca Boccassi <bluca@debian.org>  Sun, 05 Oct 2025 22:21:47 +0100

xdp-tools (1.5.7-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.5.7'

 -- Luca Boccassi <bluca@debian.org>  Sun, 05 Oct 2025 13:40:43 +0100
