## xdp-tools 1.5.8

=== debian/changelog ===
xdp-tools (1.5.8-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.5.8'
  * Drop patches, merged upstream

 -- Luca Boccassi <bluca@debian.org>  Sun, 30 Nov 2025 10:11:39 +0000
