## xdp-tools 1.6.0

=== debian/changelog ===
xdp-tools (1.6.0-1ubuntu1) resolute; urgency=medium

  * Upload a fix for new gcc and new fortify flags

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 18 Feb 2026 20:35:58 +0100

xdp-tools (1.6.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.6.0'
  * Drop priority from d/control, now defaults to optional
  * Drop Rules-Requires-Root, now defaults to no
  * Bump Standards-version to 4.7.3
  * Backport patch to fix 32bit builds
  * Update symbols file for 1.6.0

 -- Luca Boccassi <bluca@debian.org>  Sat, 10 Jan 2026 12:13:15 +0100
