=== debian/changelog ===
xdp-tools (1.6.1-1ubuntu2) resolute; urgency=medium

  * Backport new version of upstream 554.patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 19 Feb 2026 14:03:55 +0100

xdp-tools (1.6.1-1) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Add an upstrea-proposed patch to fix build when stringop-overread
    gcc flag is used

  [ Luca Boccassi ]
  * Fix watch file to find release tags
  * Update upstream source from tag 'upstream/1.6.1'
  * Drop 0001-lib-xdpsock-fix-32bit-builds.patch, merged upstream
  * Adjust DEP-3 header in 554.patch
  * Add patch to fix make clean to remove all built objects (Closes:
    #1046253)
  * Backport patch to fix 32bit build
  * Update d/copyright for removed files

 -- Luca Boccassi <bluca@debian.org>  Wed, 18 Feb 2026 23:53:17 +0000
