=== debian/control ===
--- 
+++ 
@@ -1,8 +1,6 @@
 Source: xdp-tools
 Section: devel
-Priority: optional
 Maintainer: Luca Boccassi <bluca@debian.org>
-Rules-Requires-Root: no
 Build-Depends: bpftool (>= 7.5.0~),
                clang,
                debhelper-compat (= 13),
@@ -13,7 +11,7 @@
                llvm,
                pkgconf,
                zlib1g-dev,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/xdp-project/xdp-tools
 Vcs-Browser: https://salsa.debian.org/debian/xdp-tools
 Vcs-Git: https://salsa.debian.org/debian/xdp-tools.git
