## xdp-tools 1.6.2

=== Makefile ===
--- 
+++ 
@@ -72,6 +72,7 @@
 clean: check_submodule
 	@for i in $(SUBDIRS); \
 	do $(MAKE) -C $$i clean; done
+	rm -f config.mk
 
 install: all
 	@for i in $(SUBDIRS); \
