=== debian/changelog ===
xdp-tools (1.6.2-1) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Backport new version of upstream 554.patch
  * Another patch refresh from upstream codereview

  [ Luca Boccassi ]
  * Update upstream source from tag 'upstream/1.6.2'
  * Drop patches, all merged upstream

 -- Luca Boccassi <bluca@debian.org>  Mon, 23 Feb 2026 22:24:18 +0000
